import numpy as np
import scipy.integrate

def fun1(y,x):
    return np.cos(x)*np.cos(y)

I,err=scipy.integrate.dblquad(fun1, 0.0, np.pi/2, 0.0, np.pi/2)
Iref=1
print( "%20.15f,%12.2e,%12.2e" % (I,err,np.abs(I-Iref) ))


def fun2(z,y,x):
    return np.cos(x)*np.cos(y)*np.cos(z)

I,err=scipy.integrate.tplquad(fun2, 0.0, np.pi/2, 0.0, np.pi/2, 0.0, np.pi/2)
Iref=1
print( "%20.15f,%12.2e,%12.2e" % (I,err,np.abs(I-Iref) ))


def fun3(y,x):
    return 1

I,err=scipy.integrate.dblquad(fun3, 0.0, 1.0, 0.0, lambda x: np.sqrt(1-x**2) )
Iref=np.pi/4
print( "%20.15f,%12.2e,%12.2e" % (I,err,np.abs(I-Iref) ))


def fun4(z,y,x): return 1

def range_x(): return [0.0,1.0]
def range_y(x): return [0.0,np.sqrt(1-x**2)]
def range_z(x,y): return [0.0,np.sqrt(1-x**2-y**2)]
    
I,err,info=scipy.integrate.nquad(fun4, [range_z,range_y,range_x], full_output=True)
Iref=np.pi/6
print( "%20.15f,%12.2e,%12.2e,%8d" % (I,err,np.abs(I-Iref),info['neval'] ))