import numpy as np
import scipy.integrate, scipy.special
import matplotlib.pyplot as plt

def fun1(x):
    return 1/np.sqrt(np.sin(x))

def fun2(x):
    if x<1e-6:
        return x**1.5/12
    else:
        return 1/np.sqrt(np.sin(x))-1/np.sqrt(x)

I1,err1,info1=scipy.integrate.quad(fun1, 0.0, np.pi/2,full_output=1)

I2,err2,info2=scipy.integrate.quad(fun2, 0.0, np.pi/2,full_output=1)
I2=I2+np.sqrt(2*np.pi)

I=np.sqrt(2)*scipy.special.ellipk(0.5)

print( "%s%20.15f,%12.2e,%12.2e,%8d" % ("automatic     :",I1,err1,np.abs(I1-I),info1['neval'] ))
print( "%s%20.15f,%12.2e,%12.2e,%8d" % ("sing. removed :",I2,err2,np.abs(I2-I),info2['neval'] ))
print( "%s%20.15f"                   % ("exact         :",I                                   ))

#x=np.linspace(1e-3,np.pi/2,500)
#y1=fun1(x)
#y2=np.vectorize(fun2)(x)
#plt.plot(x,y1,'r-',x,y2,'b-')
#plt.show()